unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, BufDataset, db, csvdataset, Forms, Controls, Graphics,
  Dialogs, DBGrids, ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    BufDataset1: TBufDataset;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    CSVDataset1: TCSVDataset;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  FILENAME = 'test.dat';

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  CSVDataset1.FileName := Application.Location + FILENAME;
  CSVDataset1.CSVOptions.FirstLineAsFieldNames := true;

  // When the program runs for the first time, the data file does not yet exist.
  // We must create the FieldDefs and create the dataset.
  if not FileExists(CSVDataset1.FileName) then begin
    with CSVDataset1 do begin
      FieldDefs.Add('FirstName', ftString, 20);
      FieldDefs.Add('LastName', ftstring, 20);
      FieldDefs.Add('City', ftString, 20);
      FieldDefs.Add('Address', ftString, 30);
      FieldDefs.Add('Birthdate', ftDate);
      CreateDataset;

      // Open the dataset...
      Open;

      // ... and add some dummy data:
      // Names from https://donatellanobatti.blogspot.de/
      Append;
      FieldByName('FirstName').AsString := 'Walter';
      FieldByName('LastName').AsString := 'Mellon';
      FieldByName('City').AsString := 'Oklahoma City';
      FieldByName('Address').AsString :=  '1261, Main Street';
      FieldbyName('Birthdate').AsDateTime := EncodeDate(1980, 1, 1);
      Post;

      Append;
      FieldByName('FirstName').AsString := 'Mario';
      FieldByName('LastName').AsString := 'Speedwagon';
      FieldByName('City').AsString := 'Hollywood';
      FieldByName('Address').AsString :=  '1500, Hollywood Blvd';
      FieldbyName('Birthdate').AsDateTime := EncodeDate(1982, 12, 17);
      Post;

      Append;
      FieldByName('FirstName').AsString := 'Anna';
      FieldByName('LastName').AsString := 'Mull';
      FieldByName('City').AsString := 'Los Angeles';
      FieldByName('Address').AsString :=  '2202, Capitol Square';
      FieldbyName('Birthdate').AsDateTime := EncodeDate(1982, 12, 17);
      Post;
    end;
  end;

  CSVDataset1.Open;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  CSVDataset1.SaveToCSVFile('exported.csv');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  CSVDataset1.Clear;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  CSVDataset1.LoadFromCSVFile('exported.csv');
end;

end.

